diff --git a/src/main/io/serial.c b/src/main/io/serial.c
index 09b3d877f69..a3622e0d0c0 100644
--- a/src/main/io/serial.c
+++ b/src/main/io/serial.c
@@ -372,6 +372,8 @@ void endSerialPortFunction(serialPort_t *port, serialPortFunction_e function)
     serialPortFunction_t *serialPortFunction = findSerialPortFunctionByPort(port);
 
     serialPortFunction->currentFunction = FUNCTION_NONE;
+    serialPortFunction->scenario = SCENARIO_UNUSED;
+    serialPortFunction->port = NULL;
 }
 
 functionConstraint_t *getConfiguredFunctionConstraint(serialPortFunction_e function)
